<!doctype html>
<html>
<head>
    <%- include('partials/page-head.ejs') %>
    <%- include('partials/track/track-card-metadata.ejs') %>
    <%- include('partials/track/artist-card-metadata.ejs') %>
    <title>Musicoin</title>
    <style>


            #mainFrame {
                min-height: 100%;
                width: 100%;
                height: 100%;
                flex-grow: 1;
            }

            #mainSection {
                display: flex;
                flex-direction: column;
                flex-grow: 1;
            }

            #outer {
                min-height: 100%;
                display: flex;
                flex-direction: column;
            }

            #playerFrame {
                height: 64px;
                position: fixed;
                bottom:0;
                left:0;
                width: 100%;
            }

            #playerFill {
                min-height: 64px;
            }

        body {
            background-color: #333;
            color: #eee;
            background-image: url('/images/musician.jpg');
            background-repeat: no-repeat;
            background-attachment: fixed;
            background-size: cover;
        }
        .home_icon {
            height: 80px;
        }
        .free-play-count {
            font-size: 72px;
            line-height: 0.9;
            text-align: center;
            margin-top: 20px;
            color: #e4aa17;
        }
        .social-link {
            font-size: 14pt;
        }
        @media screen and (max-width:599px) {
            #qrcode1{
                visibility: hidden !important;
            }
            #primaryEmail1 {
                visibility: hidden !important;
            }
            #abuse1{
                visibility: hidden !important;
            }
            #dp1 {
              visibility: hidden !important;
            }
        }
        @media screen and (min-width:600px) {
            #qrcode1, #primaryEmail1 {
                visibility: visible !important;
                background: none;
                font-size: 18px;
                border: none;
                color: white;
            }
            #primaryEmail1:hover {
                color: white;
            }
            #abuse1{
                visibility: visible !important;
                background: none;
                border: none;
                color: white;
            }
            #dp1 {
              visibility: visible !important;
            }
        }

    </style>
    <link rel="stylesheet" href="/styles/track-message.css">
</head>
<body onload="setupPopWatch()">

    <div id="outer">
        <div id=mainSection>

<%- include('partials/header.ejs') %>
<%- include('partials/hero2.ejs', {artist: artist, showVerifiedIcon: artist.verified}) %>
<%

const isArtist = user.profileAddress == artist.profileAddress;
function formatNumber(value) {
    if (!value || value == 0) return 0;
    if (value < 1) return parseFloat(value).toFixed(1);
    const lookup = ["", "k", "M", "B", "T"];
    var order = Math.min(Math.floor(Math.log10(value) / 3), lookup.length - 1);
    var mult = value / Math.pow(10, 3 * order);
    var decimals = order > 0 ? 1 : 0;
    return mult.toFixed(decimals).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + lookup[order];
}
%>

<div class="white-well pad20 columns-2-to-1" style="border-color: white !important">
    <div id=description class="text-justify more col1">
        <div class="more-content">
            <%
            var paragraphs = artist.description ? artist.description.split("\n").map(s => s.trim()).filter(s => s) : [];
            for (var i = 0; i < paragraphs.length; i++) {
                var paragraph = paragraphs[i];
            %>
            <%= paragraph %>
            <br><br>
            <% } %>
        </div>
        <a class="morelink clickable">show more</a>
    </div>
    <div class="flex-row col2 dynamic-data"
         de-refresh-period="20"
         de-url="/json-api/artists/earnings"
         de-artistid="<%=artist.id%>"
         data-behavior="artist-earnings"
         style="justify-content: flex-end; min-width: 200px; align-items: flex-start">
        <div class="flex-column center-text mr10 followers-container">
            <div class="follow-toggle-button btn btn-default"
                 id="follow-button"
                 user="<%= artist.id %>"
                 text-following="Following"
                 class-following="<%= isArtist ? "disabled" : "btn-success"%>"
                 text-not-following="Follow"
                 class-not-following="<%= isArtist ? "disabled" : "btn-default"%>"
                 follower-count="<%=artist.followerCount%>"
                 onclick = "$('#follow-button').css('visibility', 'hidden !important')">
                Follow
            </div>
            <div class="follower-count subtle-text"
                 data-behavior="total-followers"> - </div>
        </div>

        <div class="flex-column mr10 center-text tips-container">
            <div class="btn-group">
                <button type="button"
                        class="tip-button btn btn-success"
                        title="Tip 10 MC"
                        recipient="<%= artist.profileAddress %>"
                        amount="10"
                        context-type="User"
                        text-success="Thanks! :)"
                        text-fail=":("
                        text-default="Tip 10 MC">
                    Tip 10 MC
                </button>
                <button type="button" class="btn btn-success dropdown-toggle dropdown-toggle-split" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span class="sr-only">Toggle Dropdown</span>
                    <li class="fa fa-sort-desc"></li>
                </button>
                <ul class="dropdown-menu tip-options">
                    <%
                    var amounts = [1, 25, 50, 100, 250, 500, 1000];
                    for (var i=0; i < amounts.length; i++) {
                        var amount = amounts[i];
                        var message = amount > 1 ? "Are you sure you want to tip " + amount + " coins?" : "";
                    %>
                    <li class="tip-button"
                        recipient="<%= artist.profileAddress %>"
                        amount="<%=amount%>"
                        context-type="User"
                        text-success="Thanks! :)"
                        confirm-message="<%=message%>"
                        text-fail=":("
                        text-default="<%=amount%> MC">
                        <%=amount%> MC
                    </li>
                    <% } %>
                </ul>
            </div>
            <div class="subtle-text"><span data-behavior="total-tips"><%= formatNumber(artistStats.tipCount)%></span> tipped</div>
        </div>

        <div class="text-large flex-column center-text mr10 plays-container" >
            <div style="top: -6px; position: relative;">
                <span class="text-large" data-behavior="total-plays"><%=formatNumber(artistStats.playCount)%></span><span class="text-medium-small">PPP</span>
            </div>
            <span class="text-medium-small subtle-text" style="position: relative; top: -11px;">plays</span>
        </div>
    </div>
</div>

<div class="two-columns white-well">
    <% if (artist.verified) { %>
    <div id="lastpost" class="pad10" style="width: 60%">
        <div class="center-text event-header" style="font-size: 30px; color: #555; font-family: 'Ubuntu', sans-serif;"><i class="fa fa-comment subtle-text text-default mr10" aria-hidden="true"></i> Posts </div>
        <% if (artist.profileAddress == user.profileAddress) { %>
        <div class="post-area mb10 flex-row" style="border-bottom: 1px solid #eee">
            <a href="/artist/<%=artist.profileAddress%>"><div style="background-image: url('/images/musician.jpg')"></div></a>
            <textarea class="general-post" target="de-user-messages" placeholder="What's on your mind now? You can now compose a post in markdown!"></textarea>
        </div>
        <% } %>
        <div class="dynamic-element message-scroller"
             data-behavior="chat-message-area"
             style="min-height: 180px"
             id="de-user-messages"
             de-refresh-period="20"
             de-refresh-offset="20"
             de-showtrack="true"
             de-limit=20
             de-nocontentmessage="No messages"
             de-user="<%=artist.profileAddress%>"
             de-url="/elements/user-messages">
            <%- include('partials/track/track-messages.ejs', {messages: messages, showTrack: true, noContentMessage: "No messages"}) %>
        </div>
    </div>
    <% } else { %>
        <div id="lastpost" class="pad10" style="width: 60%">
            <div class="center-text event-header"><i class="fa fa-comment subtle-text text-default mr10" aria-hidden="true"></i> Posts (Unverified musician) </div>
            <div class="dynamic-element message-scroller"
                 data-behavior="chat-message-area"
                 style="min-height: 180px"
                 id="de-user-messages"
                 de-refresh-period="20"
                 de-refresh-offset="20"
                 de-showtrack="true"
                 de-limit=20
                 de-nocontentmessage="No messages"
                 de-user="<%=artist.profileAddress%>"
                 de-url="/elements/user-messages">
                <%- include('partials/track/track-messages.ejs', {messages: messages, showTrack: true, noContentMessage: "No messages"}) %>
            </div>
        </div>
    <% } %>

    <div class="pad10">
        <% if (releases.length > 0) { %>
          <% if (artist.verified) { %>
            <div class="event-header text-center" style="font-size: 30px; font-family: 'Ubuntu', sans-serif;">
                <i class="fa fa-cloud" style="color: #464646"></i>Releases by <%= artist.artistName %>
                <% if (typeof showPlayAll != "undefined" && showPlayAll) { %>
                <div>
                        <div class="btn btn-success party-button play-list pad5 play-all-button"
                             target="artistReleases"
                             title="Play all tracks by this artist"
                             style="border-color: white; background: #e65c00; background: -webkit-linear-gradient(to right, #F9D423, #e65c00); background: linear-gradient(to right, #F9D423, #e65c00);"
                          >
                            <i class="fa fa-play text-large mr5 text-default" aria-hidden="true" style="color: white !important"></i>PLAY ALL
                        </div>
                    </div>
                <% } %>
            </div>

            <!-- I don't see a reason for this to be a dynamic element -->
            <%- include('partials/release-events.ejs', {releases: releases, elementId: "artistReleases"}) %>
          <% } else { %>
            <div class="event-header text-center">
                Releases (Unverified Musician)
                <% if (typeof showPlayAll != "undefined" && showPlayAll) { %>
                <div>
                    <div class="btn btn-success party-button play-list pad5 play-all-button"
                         target="artistReleases"
                         title="Play all tracks by this artist">
                        <i class="fa fa-play text-large mr5 text-default" aria-hidden="true"></i> PLAY ALL
                    </div>
                </div>
                <% } %>
            </div>

            <!-- I don't see a reason for this to be a dynamic element -->
            <%- include('partials/release-events.ejs', {releases: releases.slice(0,1), elementId: "artistReleases"}) %>
          <% } %>
        <% } %>
    </div>
</div>
<!-- Artist icon -->
<% if (messages.length > 0) { %>
<div class="release-image" id="dp1" style="height: 150px; width: 150px; position: absolute; top: 110px; left: 20px; background-image: url('<%=messages[messages.length-1].sender.image%>'); border-radius: 200px;"></div>
<% } %>

</div>
<div id=playerFill class="show-on-play"></div>
<iframe id=playerFrame src="/player" frameborder="0" class="show-on-play"></iframe>
</div>

<script>
  function refreshMessageList() {
    dynamic.refreshElement($("#de-user-messages"));
  }

  $(document).ready(function() {
    dynamic.addDataHandler("artist-earnings", function(element, data) {
      var newPlays = parseInt(data.plays);
      var newTips = parseInt(data.tips);

      var newTotal = format.formatNumber(newPlays + newTips);
      var earningsElement = element.find("[data-behavior~=total-earned]");
      var earningsUSDElement = element.find("[data-behavior~=total-earned-usd]");
      var earningsContainer = element.find(".earnings-container");
      if (newTotal != earningsElement.text()) {
        earningsElement.text(newTotal);
        earningsUSDElement.text(data.formattedTotalUSD);
        earningsContainer.effect("bounce");
      }

      var tipElement = element.find("[data-behavior~=total-tips]");
      if (format.formatNumber(newTips) != tipElement.text()) {
        tipElement.text(format.formatNumber(newTips));
        element.find(".tips-container").effect("bounce");
      }
      var playElement = element.find("[data-behavior~=total-plays]");
      if (format.formatNumber(newPlays) != playElement.text()) {
        playElement.text(format.formatNumber(newPlays));
        element.find(".plays-container").effect("bounce");
      }
      var newFollowers = parseInt(data.followers);
      var followElement = element.find("[data-behavior~=total-followers]");
      if (format.formatNumber(newFollowers) != followElement.text()) {
        followElement.text(format.formatNumber(newFollowers));
        element.find(".followers-container").effect("bounce");
      }
    })
  })

  function setupPopWatch() {
    var mainFrame = document.getElementById("mainFrame");
    window.onpopstate = function(e){
      if (window.location.pathname.startsWith("/nav")) {
        mainFrame.src =  window.location.pathname.substr(4);
      }
    };
  }


  function showMessage(msg, type, timeout) {
    new Message(msg, type, timeout);
  }

</script>
<%- include('partials/player-hook.ejs') %>
<%- include('partials/connect-with-us.ejs') %>
<style>@media screen and (max-width: 800px) {#lastpost{display: none;}}</style>
</body>
</html>
